-- Sleek Free Bag Slots 2.0.3.3 By Ulti, maintained by Zorched (berSleeked version of Free Bag Slots)
local free
local total

local function spew(msg)
	DEFAULT_CHAT_FRAME:AddMessage(sfbs.NAME..": "..msg);
end

local function RegEvents()
	if sfbsOPT.disabled then this:UnregisterEvent("BAG_UPDATE")
	else this:RegisterEvent("BAG_UPDATE")
	end;
end

local function checkshown()
	if sfbsOPT.hidebag or sfbsOPT.disabled then for i = 0,4 do sfbs.bag[i]:Hide(); end
	else for i = 0,4 do sfbs.bag[i]:Show(); end
	end
	if not sfbsOPT.glo or sfbsOPT.disabled then sfbsTotal:Hide()
	else sfbsTotal:Show()
	end
end

local function IsSpecial(bag)
	local link = GetInventoryItemLink("player",GetInventorySlotInfo("bag"..bag-1 .."slot"))
	if (not link) then return true; end;
	local _,_,_,_,_,type,subtype = GetItemInfo(link);
	if type == sfbs.Container and subtype == sfbs.Bag then return nil; end
	return true
end

local function GetFree(bag,t)
	free = 0
	while (t > 0) do
		local _,item = GetContainerItemInfo(bag,t)
		if not item then free = free + 1; end
		t = t - 1
	end;
	return free
end

local function GetNumbers(bag)
	if bag == -1 then
		if sfbsOPT.hidefree then
			-- Update shortcircuits if both hidefree and hidetotal are on.
			return sfbs.tt
		else
			if sfbs.tt == 0 then sfbs.tt = 16; end
			if sfbsOPT.col then local p=sfbs.tf/sfbs.tt; sfbsTotal:SetTextColor(math.sqrt(1-p),math.sqrt(p),0.1); end
			if sfbsOPT.hidetotal then return sfbs.tf
			else return sfbs.tf.."/"..sfbs.tt
			end
		end
	end
	local glob = sfbsOPT.glo
	total = GetContainerNumSlots(bag)
	if total == 0 then return; end
	if bag > 0 and IsSpecial(bag) then
		if sfbsOPT.hideamm then sfbs.bag[bag]:Hide()
		else sfbs.bag[bag]:Show()
		end
		if sfbsOPT.skipamm then
			if sfbsOPT.hideamm then return
			else glob = nil
			end
		end
	end

	if sfbsOPT.hidefree then
		-- Update shortcircuits if both hidefree and hidetotal are on.
		if glob then sfbs.tt = sfbs.tt + total; end; return total
	else
		free = GetFree(bag,total)
		if glob then sfbs.tt = sfbs.tt + total; sfbs.tf = sfbs.tf + free; end
		if sfbsOPT.col then local p=free/total; sfbs.bag[bag]:SetTextColor(math.sqrt(1-p),math.sqrt(p),0.1); end
		if sfbsOPT.hidetotal then return free
		else return free.."/"..total
		end
	end
end

local function Update()
	if sfbsOPT.disabled or (not sfbsOPT.glo and sfbsOPT.hidebag) or (sfbsOPT.hidetotal and sfbsOPT.hidefree) then return; end
	sfbs.tf,sfbs.tt = 0,0
	for i = 0,4 do
		if sfbsOPT.hidebag then
			GetNumbers(i)
		else
			sfbs.bag[i]:SetText(GetNumbers(i))
		end
	end
	if sfbsOPT.glo then
		sfbsTotal:SetText(GetNumbers(-1))
	end
end

local function Slasher(msg)
	if not msg then spew(sfbs.USAGE); return;
	end;
	if (strfind(msg,"toggle")) then
		if sfbsOPT.disabled then sfbsOPT.disabled = nil; RegEvents(); spew(sfbs.ENABLED)
		else sfbsOPT.disabled = 1; RegEvents(); spew(sfbs.DISABLED)
		end;
	elseif (strfind(msg,"total")) then
		if sfbsOPT.hidetotal then sfbsOPT.hidetotal = nil; spew(sfbs.TOTAL..sfbs.ENABLED)
		else sfbsOPT.hidetotal = 1; spew(sfbs.TOTAL..sfbs.DISABLED)
		end;
	elseif (strfind(msg,"free")) then
		if sfbsOPT.hidefree then sfbsOPT.hidefree = nil; spew(sfbs.FREE..sfbs.ENABLED)
		else sfbsOPT.hidefree = 1; spew(sfbs.FREE..sfbs.DISABLED)
		end;
	elseif (strfind(msg,"showam")) then
		if sfbsOPT.hideamm then sfbsOPT.hideamm = nil; spew(sfbs.AMM..sfbs.ENABLED)
		else sfbsOPT.hideamm = 1; spew(sfbs.AMM..sfbs.DISABLED)
		end;
	elseif (strfind(msg,"colour")) then
		if sfbsOPT.col then sfbsOPT.col = nil; spew(sfbs.COL..sfbs.DISABLED)
			for i = 0,4 do sfbs.bag[i]:SetTextColor(1,1,1); end; sfbsTotal:SetTextColor(1,1,1,1)
		else sfbsOPT.col = 1; spew(sfbs.COL..sfbs.ENABLED)
		end;
	elseif (strfind(msg,"global")) then
		if sfbsOPT.glo then sfbsOPT.glo = nil; spew(sfbs.GLOBAL..sfbs.DISABLED); sfbsTotal:Hide()
		else sfbsOPT.glo = 1; spew(sfbs.GLOBAL..sfbs.ENABLED); sfbsTotal:Show()
		end;
	elseif strfind(msg,"perbag") then
		if sfbsOPT.hidebag then sfbsOPT.hidebag = nil; spew(sfbs.PERBAG..sfbs.ENABLED)
		else sfbsOPT.hidebag = 1; spew(sfbs.PERBAG..sfbs.DISABLED)
		end;
	elseif strfind(msg,"count") then
		if sfbsOPT.skipamm then sfbsOPT.skipamm = nil; spew(sfbs.COUNTAMM..sfbs.ENABLED)
		else sfbsOPT.skipamm = 1; spew(sfbs.COUNTAMM..sfbs.DISABLED)
		end;
	else spew(sfbs.USAGE); return;
	end;
	if (sfbsT) then TitanPanelButton_UpdateButton("SFBS"); end;
	checkshown()
	Update();
end

function sfbs.OnLoad()
	this:RegisterEvent("ADDON_LOADED");
	SlashCmdList["SFBSSLASHMAIN"] = Slasher;
	SLASH_SFBSSLASHMAIN1 = "/sleekfreebagslots";
	SLASH_SFBSSLASHMAIN2 = "/sfbs";
	spew(sfbs.VERSION.." loaded! "..sfbs.USAGE);
	sfbs.OnLoad = nil
end

function sfbs.OnEvent(event)
	if not sfbsOPT then sfbsOPT={}; end
	sfbs.bag = {}
	for i = 0,4 do
		sfbs.bag[i] = getglobal("sfbsBag"..i.."Text")
	end

	checkshown()
	RegEvents()
	this:UnregisterEvent("ADDON_LOADED")
	sfbs.OnEvent = Update
end
